/*
	kolsko natjecanje 2011
	Zadatak: Autobusi

		Opis rjeenja
	------------------------------------
	Za uspjeno rjeenja zadatka potrebno je simulirati dogaanja na kolodvoru,
	odnosno, po zadanim pravilima smjestiti sve u grupe u autobuse i zapamtiti vrijeme
	odlaska posljednje grupe.
	
	Na poetku imamo N grupa ljudi i M autobusa i pokuamo smjestiti prvu grupu u prvi autobus, 
	ukoliko ne moe stati cijela, onda ostatak grupe pokuamo smjestiti u drugi autobus, pa ako 
	je potrebno	i u trei itd. Kada cijelu prvu grupu smjestimo u odreen broj autobusa, potrebno 
	je provjeriti moe li u posljednji autbus stati i druga grupa, ako moe, provjerimo moe li 
	stati i trea grupa, itd.
	
	Openito, ako i-tu grupu pokuamo smjestiti u j-ti autobus mogue su tri situacije:
	1. Ako je broj ljudi u grupi i manji od broja mjesta u autobusu j
		- smjesti cijelu grupu u autobus j i broj mjesta umanji za broj ljudi.
		- pokuaj smjestiti i cijelu i+1 grupu. Ako moe stati, pokuaj i sa grupom i+2 itd.
	2. Ako je broj ljudi grupi i jednak broju mjesta u autobusu j
		- smjesti cijelu grupu u autobus
	3. Ako je broj ljudi u grupi i vei od broja mjesta u autobusu j
		- od broja ljudi u grupi i oduzmi broj mjesta u autobusu
		- ostatak pokuaj smjestiti u autobus j+1 na nain da se provjere ove tri situacije
		  za grupu i (sa umanjenim brojem ljudi) i autobus j+1
*/

#include <iostream>
#include <vector>


using namespace std;

int main()
{
	int n;
	cin >> n;

	vector <int> groups;
	groups.resize(n);

	for (int i=0; i<n; i++)
	{
		cin >> groups[i];
	}

	int m;
	cin >> m;

	vector<pair<int, int> > buses;
	buses.resize(m);

	for (int i=0; i<m; i++)
	{
		cin >> buses[i].first >> buses[i].second;
	}

	int currentBus = 0, currentGroup = 0;
	int lastDeparture = -1;

	while (currentGroup != n)
	{
		if (groups[currentGroup] < buses[currentBus].second)
		{
			lastDeparture = buses[currentBus].first + 1;
			
			buses[currentBus].second -= groups[currentGroup];

			currentGroup++;

			while (currentGroup != n)
			{
				if (groups[currentGroup] <= buses[currentBus].second)
				{
					lastDeparture = buses[currentBus].first + 1;

					buses[currentBus].second -= groups[currentGroup];

					currentGroup++;
				}
				else
				{
					break;
				}
			}

			currentBus++;
		}
		else if (groups[currentGroup] == buses[currentBus].second)
		{
			lastDeparture = buses[currentBus].first + 1;

			currentGroup++;

			currentBus++;
		}
		else
		{
			groups[currentGroup] -= buses[currentBus].second;

			currentBus++;
		}
	}

	cout << lastDeparture << endl;
}